package com.hardkernel.bmp180;

import android.app.Activity;
import android.content.Context;
import android.hardware.Sensor;
import android.hardware.SensorEvent;
import android.hardware.SensorEventListener;
import android.hardware.SensorManager;
import android.os.Bundle;
import android.util.Log;
import android.widget.TextView;

public class BMP180Activity extends Activity implements SensorEventListener {
	private SensorManager mSensorManager;
	private Sensor mSensorPressure;
	private Sensor mSensorTemperature;
	private static final String TAG = "BMP180";
	private TextView mTextViewPressure;
	private TextView mTextViewTemperature;
	private TextView mTextViewAltitude;
    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);
        
        mTextViewPressure = (TextView)findViewById(R.id.tv_pressure);
        mTextViewTemperature = (TextView)findViewById(R.id.tv_temperature);
        mTextViewAltitude = (TextView)findViewById(R.id.tv_altitude);
        
        mSensorManager = (SensorManager)getSystemService(Context.SENSOR_SERVICE);
        mSensorPressure = mSensorManager.getDefaultSensor(Sensor.TYPE_PRESSURE);
        mSensorTemperature = mSensorManager.getDefaultSensor(Sensor.TYPE_AMBIENT_TEMPERATURE);
    }
    
    
	@Override
	protected void onPause() {
		// TODO Auto-generated method stub
		super.onPause();
		mSensorManager.unregisterListener(this);
	}


	@Override
	protected void onResume() {
		// TODO Auto-generated method stub
		super.onResume();
		mSensorManager.registerListener(this, mSensorPressure, SensorManager.SENSOR_DELAY_NORMAL);
		mSensorManager.registerListener(this, mSensorTemperature, SensorManager.SENSOR_DELAY_NORMAL);
	}


	@Override
	public void onAccuracyChanged(Sensor sensor, int accuracy) {
		// TODO Auto-generated method stub
		
	}
	@Override
	public void onSensorChanged(SensorEvent event) {
		// TODO Auto-generated method stub
		if (event.sensor.getType() == Sensor.TYPE_PRESSURE) {
			//Log.e(TAG, "Pressure " + event.values[0] + " hPa");
			mTextViewPressure.setText(String.format("%.1f", event.values[0]) + " hPa");
			long altitude = (long)(44330.0 * (1.0 - Math.pow((double)(event.values[0] * 100 / 101325.0), 1/5.255)));
			//mTextViewAltitude.setText(String.format("%.0f", altitude) + " m");
			mTextViewAltitude.setText(altitude + " m");
		} else if (event.sensor.getType() == Sensor.TYPE_AMBIENT_TEMPERATURE) {
			//Log.e(TAG, "Temperature " + event.values[0] + " °C");
			mTextViewTemperature.setText(String.format("%.1f", event.values[0]) + " °C");
		}
	}
}